diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/val-array-test-suite.cc ns-3.42/src/core/test/val-array-test-suite.cc
--- ns-3.41/src/core/test/val-array-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/val-array-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -22,6 +22,19 @@
 #include "ns3/val-array.h"
 
 /**
+ * \defgroup valArray-tests ValArray tests
+ * \ingroup core-tests
+ * \ingroup Matrices
+ */
+
+/**
+ * \file
+ * \ingroup valArray-tests
+ * ValArray test suite
+ */
+
+/**
+ * \file
  * \ingroup core-tests
  */
 
@@ -33,6 +46,8 @@
 NS_LOG_COMPONENT_DEFINE("ValArrayTest");
 
 /**
+ * @ingroup valArray-tests
+ *
  * @brief ValArray test case for testing ValArray class
  *
  * @tparam T the template parameter that can be a complex number, double or int
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/csma/model/csma-net-device.cc ns-3.42/src/csma/model/csma-net-device.cc
--- ns-3.41/src/csma/model/csma-net-device.cc	2024-02-09 14:44:07.897790000 -0800
+++ ns-3.42/src/csma/model/csma-net-device.cc	2024-05-29 15:29:46.940073000 -0700
@@ -912,7 +912,7 @@
 CsmaNetDevice::GetBroadcast() const
 {
     NS_LOG_FUNCTION_NOARGS();
-    return Mac48Address("ff:ff:ff:ff:ff:ff");
+    return Mac48Address::GetBroadcast();
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/dsdv/examples/dsdv-manet.cc ns-3.42/src/dsdv/examples/dsdv-manet.cc
--- ns-3.41/src/dsdv/examples/dsdv-manet.cc	2024-02-09 14:44:07.897790000 -0800
+++ ns-3.42/src/dsdv/examples/dsdv-manet.cc	2024-05-29 15:29:46.940073000 -0700
@@ -46,9 +46,13 @@
 NS_LOG_COMPONENT_DEFINE("DsdvManetExample");
 
 /**
+ * \defgroup dsdv-examples DSDV Examples
  * \ingroup dsdv
- * \ingroup dsdv-examples
  * \ingroup examples
+ */
+
+/**
+ * \ingroup dsdv-examples
  *
  * \brief DSDV Manet example
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/dsdv/model/dsdv-rtable.cc ns-3.42/src/dsdv/model/dsdv-rtable.cc
--- ns-3.41/src/dsdv/model/dsdv-rtable.cc	2024-02-09 14:44:07.897790000 -0800
+++ ns-3.42/src/dsdv/model/dsdv-rtable.cc	2024-05-29 15:29:46.944073200 -0700
@@ -312,7 +312,7 @@
         return false;
     }
     event = i->second;
-    return event.IsRunning();
+    return event.IsPending();
 }
 
 bool
@@ -340,7 +340,7 @@
         return false;
     }
     event = i->second;
-    if (event.IsRunning())
+    if (event.IsPending())
     {
         return false;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/dsdv/test/dsdv-testcase.cc ns-3.42/src/dsdv/test/dsdv-testcase.cc
--- ns-3.41/src/dsdv/test/dsdv-testcase.cc	2024-02-09 14:44:07.897790000 -0800
+++ ns-3.42/src/dsdv/test/dsdv-testcase.cc	2024-05-29 15:29:46.944073200 -0700
@@ -218,9 +218,9 @@
 {
   public:
     DsdvTestSuite()
-        : TestSuite("routing-dsdv", UNIT)
+        : TestSuite("routing-dsdv", Type::UNIT)
     {
-        AddTestCase(new DsdvHeaderTestCase(), TestCase::QUICK);
-        AddTestCase(new DsdvTableTestCase(), TestCase::QUICK);
+        AddTestCase(new DsdvHeaderTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new DsdvTableTestCase(), TestCase::Duration::QUICK);
     }
 } g_dsdvTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/dsr/model/dsr-fs-header.cc ns-3.42/src/dsr/model/dsr-fs-header.cc
--- ns-3.41/src/dsr/model/dsr-fs-header.cc	2024-02-09 14:44:07.897790000 -0800
+++ ns-3.42/src/dsr/model/dsr-fs-header.cc	2024-05-29 15:29:46.944073200 -0700
@@ -34,6 +34,8 @@
 #include "ns3/header.h"
 #include "ns3/log.h"
 
+#include <vector>
+
 namespace ns3
 {
 
@@ -174,9 +176,9 @@
     m_destId = i.ReadU16();
     m_payloadLen = i.ReadU16();
 
-    uint32_t dataLength = GetPayloadLength();
-    uint8_t data[dataLength];
-    i.Read(data, dataLength);
+    const uint32_t dataLength = GetPayloadLength();
+    std::vector<uint8_t> data(dataLength);
+    i.Read(data.data(), dataLength);
 
     if (dataLength > m_data.GetSize())
     {
@@ -188,7 +190,7 @@
     }
 
     i = m_data.Begin();
-    i.Write(data, dataLength);
+    i.Write(data.data(), data.size());
 
     return GetSerializedSize();
 }
@@ -233,11 +235,11 @@
 uint32_t
 DsrOptionField::Deserialize(Buffer::Iterator start, uint32_t length)
 {
-    uint8_t buf[length];
-    start.Read(buf, length);
+    std::vector<uint8_t> buf(length);
+    start.Read(buf.data(), length);
     m_optionData = Buffer();
     m_optionData.AddAtEnd(length);
-    m_optionData.Begin().Write(buf, length);
+    m_optionData.Begin().Write(buf.data(), buf.size());
     return length;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/dsr/model/dsr-maintain-buff.h ns-3.42/src/dsr/model/dsr-maintain-buff.h
--- ns-3.41/src/dsr/model/dsr-maintain-buff.h	2024-02-09 14:44:07.897790000 -0800
+++ ns-3.42/src/dsr/model/dsr-maintain-buff.h	2024-05-29 15:29:46.944073200 -0700
@@ -477,7 +477,7 @@
 
     /**
      * Set maintain buffer timeout
-     * \param t the maintain buffer timeoout
+     * \param t the maintain buffer timeout
      */
     void SetMaintainBufferTimeout(Time t)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/dsr/model/dsr-option-header.h ns-3.42/src/dsr/model/dsr-option-header.h
--- ns-3.41/src/dsr/model/dsr-option-header.h	2024-02-09 14:44:07.901790100 -0800
+++ ns-3.42/src/dsr/model/dsr-option-header.h	2024-05-29 15:29:46.944073200 -0700
@@ -384,7 +384,7 @@
      */
     Ipv4Address m_target;
     /**
-     * Ipv4 address to write when desearizing the packet
+     * Ipv4 address to write when deserializing the packet
      */
     Ipv4Address m_address;
     /**
@@ -673,7 +673,7 @@
 
   private:
     /**
-     * \brief The ip address header deserilize to
+     * \brief The ip address header deserialize to
      */
     Ipv4Address m_address;
     /**
@@ -681,7 +681,7 @@
      */
     uint8_t m_segmentsLeft;
     /**
-     * \brief Number of savlage times for a packet.
+     * \brief Number of salvage times for a packet.
      */
     uint8_t m_salvage;
     /**
@@ -821,7 +821,7 @@
      */
     uint8_t m_errorType;
     /**
-     * \brief The salavage field
+     * \brief The salvage field
      */
     uint8_t m_salvage;
     /**
@@ -976,7 +976,7 @@
      */
     uint8_t m_errorType;
     /**
-     * \brief The salavage field
+     * \brief The salvage field
      */
     uint8_t m_salvage;
     /**
@@ -1122,7 +1122,7 @@
      */
     uint8_t m_errorType;
     /**
-     * \brief The salavage field
+     * \brief The salvage field
      */
     uint8_t m_salvage;
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/dsr/model/dsr-rcache.cc ns-3.42/src/dsr/model/dsr-rcache.cc
--- ns-3.41/src/dsr/model/dsr-rcache.cc	2024-02-09 14:44:07.901790100 -0800
+++ ns-3.42/src/dsr/model/dsr-rcache.cc	2024-05-29 15:29:46.944073200 -0700
@@ -799,7 +799,7 @@
         auto i = m_nodeCache.find(errorSrc);
         if (i == m_nodeCache.end())
         {
-            NS_LOG_LOGIC("Update the node stability unsuccessfuly");
+            NS_LOG_LOGIC("Update the node stability unsuccessfully");
         }
         else
         {
@@ -808,7 +808,7 @@
         i = m_nodeCache.find(unreachNode);
         if (i == m_nodeCache.end())
         {
-            NS_LOG_LOGIC("Update the node stability unsuccessfuly");
+            NS_LOG_LOGIC("Update the node stability unsuccessfully");
         }
         else
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/dsr/model/dsr-routing.cc ns-3.42/src/dsr/model/dsr-routing.cc
--- ns-3.41/src/dsr/model/dsr-routing.cc	2024-02-09 14:44:07.901790100 -0800
+++ ns-3.42/src/dsr/model/dsr-routing.cc	2024-05-29 15:29:46.944073200 -0700
@@ -136,7 +136,7 @@
             .AddAttribute(
                 "PassiveBuffer",
                 "The passive buffer to manage "
-                "promisucously received passive ack.",
+                "promiscuously received passive ack.",
                 PointerValue(nullptr),
                 MakePointerAccessor(&DsrRouting::SetPassiveBuffer, &DsrRouting::GetPassiveBuffer),
                 MakePointerChecker<DsrPassiveBuffer>())
@@ -1122,7 +1122,7 @@
     /*
      * Message type 2 means the data packet, we will further process the data
      * packet for delivery notification, safely ignore control packet
-     * Another check here is our own address, if this is the data destinated for us,
+     * Another check here is our own address, if this is the data destined for us,
      * process it further, otherwise, just ignore it
      */
     Ipv4Address ourAddress = m_ipv4->GetAddress(1, 0).GetLocal();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/dsr/model/dsr-rreq-table.h ns-3.42/src/dsr/model/dsr-rreq-table.h
--- ns-3.41/src/dsr/model/dsr-rreq-table.h	2024-02-09 14:44:07.901790100 -0800
+++ ns-3.42/src/dsr/model/dsr-rreq-table.h	2024-05-29 15:29:46.944073200 -0700
@@ -373,7 +373,7 @@
     Time MaxRequestPeriod;
     /// The original request period
     Time RequestPeriod;
-    /// The non-propagaton request timeout
+    /// The non-propagation request timeout
     Time NonpropRequestTimeout;
     /// The source route entry expire time
     Time m_rreqEntryExpire;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/dsr/test/dsr-test-suite.cc ns-3.42/src/dsr/test/dsr-test-suite.cc
--- ns-3.41/src/dsr/test/dsr-test-suite.cc	2024-02-09 14:44:07.901790100 -0800
+++ ns-3.42/src/dsr/test/dsr-test-suite.cc	2024-05-29 15:29:46.944073200 -0700
@@ -630,16 +630,16 @@
 {
   public:
     DsrTestSuite()
-        : TestSuite("routing-dsr", UNIT)
+        : TestSuite("routing-dsr", Type::UNIT)
     {
-        AddTestCase(new DsrFsHeaderTest, TestCase::QUICK);
-        AddTestCase(new DsrRreqHeaderTest, TestCase::QUICK);
-        AddTestCase(new DsrRrepHeaderTest, TestCase::QUICK);
-        AddTestCase(new DsrSRHeaderTest, TestCase::QUICK);
-        AddTestCase(new DsrRerrHeaderTest, TestCase::QUICK);
-        AddTestCase(new DsrAckReqHeaderTest, TestCase::QUICK);
-        AddTestCase(new DsrAckHeaderTest, TestCase::QUICK);
-        AddTestCase(new DsrCacheEntryTest, TestCase::QUICK);
-        AddTestCase(new DsrSendBuffTest, TestCase::QUICK);
+        AddTestCase(new DsrFsHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new DsrRreqHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new DsrRrepHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new DsrSRHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new DsrRerrHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new DsrAckReqHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new DsrAckHeaderTest, TestCase::Duration::QUICK);
+        AddTestCase(new DsrCacheEntryTest, TestCase::Duration::QUICK);
+        AddTestCase(new DsrSendBuffTest, TestCase::Duration::QUICK);
     }
 } g_dsrTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/examples/basic-energy-model-test.cc ns-3.42/src/energy/examples/basic-energy-model-test.cc
--- ns-3.41/src/energy/examples/basic-energy-model-test.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/examples/basic-energy-model-test.cc	2024-05-29 15:29:46.948073100 -0700
@@ -34,6 +34,7 @@
 #include <cmath>
 
 using namespace ns3;
+using namespace ns3::energy;
 
 NS_LOG_COMPONENT_DEFINE("BasicEnergyModelTestSuite");
 
@@ -165,7 +166,10 @@
      */
 
     // schedule change of state
-    Simulator::Schedule(Seconds(m_timeS), &WifiRadioEnergyModel::ChangeState, devModel, state);
+    Simulator::Schedule(Seconds(m_timeS),
+                        &WifiRadioEnergyModel::ChangeState,
+                        devModel,
+                        static_cast<int>(state));
 
     // Calculate remaining energy at simulation stop time
     Simulator::Schedule(Seconds(m_timeS * 2), &BasicEnergySource::UpdateEnergySource, source);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/examples/generic-battery-discharge-example.cc ns-3.42/src/energy/examples/generic-battery-discharge-example.cc
--- ns-3.41/src/energy/examples/generic-battery-discharge-example.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/examples/generic-battery-discharge-example.cc	2024-05-29 15:29:46.948073100 -0700
@@ -26,6 +26,7 @@
 #include <string>
 
 using namespace ns3;
+using namespace ns3::energy;
 
 /**
  * This example shows the use of batteries in ns-3.
@@ -44,8 +45,10 @@
  *
  * Plot files are produced as a result of this example.
  * Graphs can be obtained from the plot using:
+ * \code{.sh}
+   $> gnuplot <plotname>.plt
+   \endcode
  *
- * $> gnuplot <plotname>.plt
  */
 
 Gnuplot battDischPlot1 = Gnuplot("BattDisch1.eps");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/examples/generic-battery-discharge-example.py ns-3.42/src/energy/examples/generic-battery-discharge-example.py
--- ns-3.41/src/energy/examples/generic-battery-discharge-example.py	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/examples/generic-battery-discharge-example.py	2024-05-29 15:29:46.948073100 -0700
@@ -37,27 +37,29 @@
     argv: System parameters to use if necessary
     """
 
-    ns.core.LogComponentEnable("GenericBatteryModel", ns.core.LOG_LEVEL_DEBUG)
+    ns.LogComponentEnable("GenericBatteryModel", ns.LOG_LEVEL_DEBUG)
 
-    node = ns.network.Node()
-    batteryHelper = ns.energy.GenericBatteryModelHelper()
-    batteryModel = ns.CreateObject("GenericBatteryModel")
+    node = ns.Node()
+    batteryHelper = ns.GenericBatteryModelHelper()
+    batteryModel = ns.CreateObject[ns.energy.GenericBatteryModel]()
     devicesEnergyModel = ns.energy.SimpleDeviceEnergyModel()
 
-    batteryModel.SetAttribute("FullVoltage", ns.core.DoubleValue(1.39))  # Vfull
-    batteryModel.SetAttribute("MaxCapacity", ns.core.DoubleValue(7.0))  # Q
+    batteryModel.SetAttribute("FullVoltage", ns.DoubleValue(1.39))  # Vfull
+    batteryModel.SetAttribute("MaxCapacity", ns.DoubleValue(7.0))  # Q
 
-    batteryModel.SetAttribute("NominalVoltage", ns.core.DoubleValue(1.18))  # Vnom
-    batteryModel.SetAttribute("NominalCapacity", ns.core.DoubleValue(6.25))  # QNom
+    batteryModel.SetAttribute("NominalVoltage", ns.DoubleValue(1.18))  # Vnom
+    batteryModel.SetAttribute("NominalCapacity", ns.DoubleValue(6.25))  # QNom
 
-    batteryModel.SetAttribute("ExponentialVoltage", ns.core.DoubleValue(1.28))  # Vexp
-    batteryModel.SetAttribute("ExponentialCapacity", ns.core.DoubleValue(1.3))  # Qexp
+    batteryModel.SetAttribute("ExponentialVoltage", ns.DoubleValue(1.28))  # Vexp
+    batteryModel.SetAttribute("ExponentialCapacity", ns.DoubleValue(1.3))  # Qexp
 
-    batteryModel.SetAttribute("InternalResistance", ns.core.DoubleValue(0.0046))  # R
-    batteryModel.SetAttribute("TypicalDischargeCurrent", ns.core.DoubleValue(1.3))  # i typical
-    batteryModel.SetAttribute("CutoffVoltage", ns.core.DoubleValue(1.0))  # End of charge.
-
-    batteryModel.SetAttribute("BatteryType", ns.core.EnumValue(ns.NIMH_NICD))  # Battery type
+    batteryModel.SetAttribute("InternalResistance", ns.DoubleValue(0.0046))  # R
+    batteryModel.SetAttribute("TypicalDischargeCurrent", ns.DoubleValue(1.3))  # i typical
+    batteryModel.SetAttribute("CutoffVoltage", ns.DoubleValue(1.0))  # End of charge.
+
+    batteryModel.SetAttribute(
+        "BatteryType", ns.EnumValue[ns.energy.GenericBatteryType](ns.energy.NIMH_NICD)
+    )  # Battery type
 
     devicesEnergyModel.SetEnergySource(batteryModel)
     batteryModel.AppendDeviceEnergyModel(devicesEnergyModel)
@@ -65,9 +67,9 @@
 
     devicesEnergyModel.SetCurrentA(6.5)
 
-    ns.core.Simulator.Stop(ns.core.Seconds(3600))
-    ns.core.Simulator.Run()
-    ns.core.Simulator.Destroy()
+    ns.Simulator.Stop(ns.Seconds(3600))
+    ns.Simulator.Run()
+    ns.Simulator.Destroy()
 
 
 if __name__ == "__main__":
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/examples/generic-battery-wifiradio-example.cc ns-3.42/src/energy/examples/generic-battery-wifiradio-example.cc
--- ns-3.41/src/energy/examples/generic-battery-wifiradio-example.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/examples/generic-battery-wifiradio-example.cc	2024-05-29 15:29:46.948073100 -0700
@@ -48,6 +48,7 @@
 #include <string>
 
 using namespace ns3;
+using namespace ns3::energy;
 
 NS_LOG_COMPONENT_DEFINE("GenericBatteryWifiRadioExample");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/examples/li-ion-energy-source-example.cc ns-3.42/src/energy/examples/li-ion-energy-source-example.cc
--- ns-3.41/src/energy/examples/li-ion-energy-source-example.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/examples/li-ion-energy-source-example.cc	2024-05-29 15:29:46.948073100 -0700
@@ -25,6 +25,7 @@
 #include "ns3/simulator.h"
 
 using namespace ns3;
+using namespace ns3::energy;
 
 /**
  * In this simple example, we show how to create and drain energy from a
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/examples/rv-battery-model-test.cc ns-3.42/src/energy/examples/rv-battery-model-test.cc
--- ns-3.41/src/energy/examples/rv-battery-model-test.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/examples/rv-battery-model-test.cc	2024-05-29 15:29:46.948073100 -0700
@@ -35,6 +35,7 @@
 #include <cmath>
 
 using namespace ns3;
+using namespace ns3::energy;
 
 NS_LOG_COMPONENT_DEFINE("RvBatteryModelTestSuite");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/basic-energy-harvester-helper.cc ns-3.42/src/energy/helper/basic-energy-harvester-helper.cc
--- ns-3.41/src/energy/helper/basic-energy-harvester-helper.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/basic-energy-harvester-helper.cc	2024-05-29 15:29:46.948073100 -0700
@@ -40,14 +40,15 @@
     m_basicEnergyHarvester.Set(name, v);
 }
 
-Ptr<EnergyHarvester>
-BasicEnergyHarvesterHelper::DoInstall(Ptr<EnergySource> source) const
+Ptr<energy::EnergyHarvester>
+BasicEnergyHarvesterHelper::DoInstall(Ptr<energy::EnergySource> source) const
 {
     NS_ASSERT(source);
     Ptr<Node> node = source->GetNode();
 
     // Create a new Basic Energy Harvester
-    Ptr<EnergyHarvester> harvester = m_basicEnergyHarvester.Create<EnergyHarvester>();
+    Ptr<energy::EnergyHarvester> harvester =
+        m_basicEnergyHarvester.Create<energy::EnergyHarvester>();
     NS_ASSERT(harvester);
 
     // Connect the Basic Energy Harvester to the Energy Source
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/basic-energy-harvester-helper.h ns-3.42/src/energy/helper/basic-energy-harvester-helper.h
--- ns-3.41/src/energy/helper/basic-energy-harvester-helper.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/basic-energy-harvester-helper.h	2024-05-29 15:29:46.948073100 -0700
@@ -42,7 +42,7 @@
     void Set(std::string name, const AttributeValue& v) override;
 
   private:
-    Ptr<EnergyHarvester> DoInstall(Ptr<EnergySource> source) const override;
+    Ptr<energy::EnergyHarvester> DoInstall(Ptr<energy::EnergySource> source) const override;
 
   private:
     ObjectFactory m_basicEnergyHarvester; //!< Energy source factory
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/basic-energy-source-helper.cc ns-3.42/src/energy/helper/basic-energy-source-helper.cc
--- ns-3.41/src/energy/helper/basic-energy-source-helper.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/basic-energy-source-helper.cc	2024-05-29 15:29:46.948073100 -0700
@@ -39,11 +39,11 @@
     m_basicEnergySource.Set(name, v);
 }
 
-Ptr<EnergySource>
+Ptr<energy::EnergySource>
 BasicEnergySourceHelper::DoInstall(Ptr<Node> node) const
 {
     NS_ASSERT(node);
-    Ptr<EnergySource> source = m_basicEnergySource.Create<EnergySource>();
+    Ptr<energy::EnergySource> source = m_basicEnergySource.Create<energy::EnergySource>();
     NS_ASSERT(source);
     source->SetNode(node);
     return source;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/basic-energy-source-helper.h ns-3.42/src/energy/helper/basic-energy-source-helper.h
--- ns-3.41/src/energy/helper/basic-energy-source-helper.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/basic-energy-source-helper.h	2024-05-29 15:29:46.948073100 -0700
@@ -41,7 +41,7 @@
     void Set(std::string name, const AttributeValue& v) override;
 
   private:
-    Ptr<EnergySource> DoInstall(Ptr<Node> node) const override;
+    Ptr<energy::EnergySource> DoInstall(Ptr<Node> node) const override;
 
   private:
     ObjectFactory m_basicEnergySource; //!< Energy source factory
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/energy-harvester-container.cc ns-3.42/src/energy/helper/energy-harvester-container.cc
--- ns-3.41/src/energy/helper/energy-harvester-container.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/energy-harvester-container.cc	2024-05-29 15:29:46.948073100 -0700
@@ -25,9 +25,10 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 NS_LOG_COMPONENT_DEFINE("EnergyHarvesterContainer");
-
 NS_OBJECT_ENSURE_REGISTERED(EnergyHarvesterContainer);
 
 TypeId
@@ -160,4 +161,5 @@
     }
 }
 
+} // namespace energy
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/energy-harvester-container.h ns-3.42/src/energy/helper/energy-harvester-container.h
--- ns-3.41/src/energy/helper/energy-harvester-container.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/energy-harvester-container.h	2024-05-29 15:29:46.948073100 -0700
@@ -29,6 +29,8 @@
 
 namespace ns3
 {
+namespace energy
+{
 
 class EnergyHarvester;
 
@@ -188,6 +190,7 @@
     std::vector<Ptr<EnergyHarvester>> m_harvesters; //!< Harvester container
 };
 
+} // namespace energy
 } // namespace ns3
 
 #endif /* defined(ENERGY_HARVESTER_CONTAINER_H) */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/energy-harvester-helper.cc ns-3.42/src/energy/helper/energy-harvester-helper.cc
--- ns-3.41/src/energy/helper/energy-harvester-helper.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/energy-harvester-helper.cc	2024-05-29 15:29:46.948073100 -0700
@@ -33,32 +33,32 @@
 {
 }
 
-EnergyHarvesterContainer
-EnergyHarvesterHelper::Install(Ptr<EnergySource> source) const
+energy::EnergyHarvesterContainer
+EnergyHarvesterHelper::Install(Ptr<energy::EnergySource> source) const
 {
-    return Install(EnergySourceContainer(source));
+    return Install(energy::EnergySourceContainer(source));
 }
 
-EnergyHarvesterContainer
-EnergyHarvesterHelper::Install(EnergySourceContainer sourceContainer) const
+energy::EnergyHarvesterContainer
+EnergyHarvesterHelper::Install(energy::EnergySourceContainer sourceContainer) const
 {
-    EnergyHarvesterContainer container;
+    energy::EnergyHarvesterContainer container;
     for (auto i = sourceContainer.Begin(); i != sourceContainer.End(); ++i)
     {
-        Ptr<EnergyHarvester> harvester = DoInstall(*i);
+        Ptr<energy::EnergyHarvester> harvester = DoInstall(*i);
         container.Add(harvester);
         Ptr<Node> node = (*i)->GetNode();
         /*
          * Check if EnergyHarvesterContainer is already aggregated to target node. If
          * not, create a new EnergyHarvesterContainer and aggregate it to the node.
          */
-        Ptr<EnergyHarvesterContainer> EnergyHarvesterContainerOnNode =
-            node->GetObject<EnergyHarvesterContainer>();
+        Ptr<energy::EnergyHarvesterContainer> EnergyHarvesterContainerOnNode =
+            node->GetObject<energy::EnergyHarvesterContainer>();
         if (!EnergyHarvesterContainerOnNode)
         {
             ObjectFactory fac;
             fac.SetTypeId("ns3::EnergyHarvesterContainer");
-            EnergyHarvesterContainerOnNode = fac.Create<EnergyHarvesterContainer>();
+            EnergyHarvesterContainerOnNode = fac.Create<energy::EnergyHarvesterContainer>();
             EnergyHarvesterContainerOnNode->Add(harvester);
             node->AggregateObject(EnergyHarvesterContainerOnNode);
         }
@@ -70,10 +70,10 @@
     return container;
 }
 
-EnergyHarvesterContainer
+energy::EnergyHarvesterContainer
 EnergyHarvesterHelper::Install(std::string sourceName) const
 {
-    Ptr<EnergySource> source = Names::Find<EnergySource>(sourceName);
+    Ptr<energy::EnergySource> source = Names::Find<energy::EnergySource>(sourceName);
     return Install(source);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/energy-harvester-helper.h ns-3.42/src/energy/helper/energy-harvester-helper.h
--- ns-3.41/src/energy/helper/energy-harvester-helper.h	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/energy-harvester-helper.h	2024-05-29 15:29:46.948073100 -0700
@@ -60,7 +60,7 @@
      *
      * This function installs an EnergyHarvester onto an energy source.
      */
-    EnergyHarvesterContainer Install(Ptr<EnergySource> source) const;
+    energy::EnergyHarvesterContainer Install(Ptr<energy::EnergySource> source) const;
 
     /**
      * \param sourceContainer List of nodes where EnergyHarvester will be installed.
@@ -68,7 +68,7 @@
      *
      * This function installs an EnergyHarvester onto a list of energy sources.
      */
-    EnergyHarvesterContainer Install(EnergySourceContainer sourceContainer) const;
+    energy::EnergyHarvesterContainer Install(energy::EnergySourceContainer sourceContainer) const;
 
     /**
      * \param sourceName Name of node where EnergyHarvester will be installed.
@@ -76,7 +76,7 @@
      *
      * This function installs an EnergyHarvester onto a node.
      */
-    EnergyHarvesterContainer Install(std::string sourceName) const;
+    energy::EnergyHarvesterContainer Install(std::string sourceName) const;
 
   private:
     /**
@@ -88,7 +88,7 @@
      * the installation process (eg. installing EnergyHarvester on set of nodes) is
      * implemented in the EnergyHarvesterHelper base class.
      */
-    virtual Ptr<EnergyHarvester> DoInstall(Ptr<EnergySource> source) const = 0;
+    virtual Ptr<energy::EnergyHarvester> DoInstall(Ptr<energy::EnergySource> source) const = 0;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/energy/helper/energy-model-helper.cc ns-3.42/src/energy/helper/energy-model-helper.cc
--- ns-3.41/src/energy/helper/energy-model-helper.cc	2024-02-09 14:44:07.905790000 -0800
+++ ns-3.42/src/energy/helper/energy-model-helper.cc	2024-05-29 15:29:46.948073100 -0700
@@ -32,31 +32,31 @@
 {
 }
 
-EnergySourceContainer
+energy::EnergySourceContainer
 EnergySourceHelper::Install(Ptr<Node> node) const
 {
     return Install(NodeContainer(node));
 }
 
-EnergySourceContainer
+energy::EnergySourceContainer
 EnergySourceHelper::Install(NodeContainer c) const
 {
-    EnergySourceContainer container;
+    energy::EnergySourceContainer container;
     for (auto i = c.Begin(); i != c.End(); ++i)
     {
-        Ptr<EnergySource> src = DoInstall(*i);
+        Ptr<energy::EnergySource> src = DoInstall(*i);
         container.Add(src);
         /*
          * Check if EnergySourceContainer is already aggregated to target node. If
          * not, create a new EnergySourceContainer and aggregate it to node.
          */
-        Ptr<EnergySourceContainer> EnergySourceContainerOnNode =
-            (*i)->GetObject<EnergySourceContainer>();
+        Ptr<energy::EnergySourceContainer> EnergySourceContainerOnNode =
+            (*i)->GetObject<energy::EnergySourceContainer>();
         if (!EnergySourceContainerOnNode)
         {
             ObjectFactory fac;
             fac.SetTypeId("ns3::EnergySourceContainer");
-            EnergySourceContainerOnNode = fac.Create<EnergySourceContainer>();
+            EnergySourceContainerOnNode = fac.Create<energy::EnergySourceContainer>();
             EnergySourceContainerOnNode->Add(src);
             (*i)->AggregateObject(EnergySourceContainerOnNode);
         }
@@ -68,14 +68,14 @@
     return container;
 }
 
-EnergySourceContainer
+energy::EnergySourceContainer
 EnergySourceHelper::Install(std::string nodeName) const
 {
     Ptr<Node> node = Names::Find<Node>(nodeName);
     return Install(node);
 }
 
-EnergySourceContainer
+energy::EnergySourceContainer
 EnergySourceHelper::InstallAll() const
 {
     return Install(NodeContainer::GetGlobal());
@@ -88,30 +88,30 @@
 {
 }
 
-DeviceEnergyModelContainer
-DeviceEnergyModelHelper::Install(Ptr<NetDevice> device, Ptr<EnergySource> source) const
+energy::DeviceEnergyModelContainer
+DeviceEnergyModelHelper::Install(Ptr<NetDevice> device, Ptr<energy::EnergySource> source) const
 {
     NS_ASSERT(device);
     NS_ASSERT(source);
     // check to make sure source and net device are on the same node
     NS_ASSERT(device->GetNode() == source->GetNode());
-    DeviceEnergyModelContainer container(DoInstall(device, source));
+    energy::DeviceEnergyModelContainer container(DoInstall(device, source));
     return container;
 }
 
-DeviceEnergyModelContainer
+energy::DeviceEnergyModelContainer
 DeviceEnergyModelHelper::Install(NetDeviceContainer deviceContainer,
-                                 EnergySourceContainer sourceContainer) const
+                                 energy::EnergySourceContainer sourceContainer) const
 {
     NS_ASSERT(deviceContainer.GetN() <= sourceContainer.GetN());
-    DeviceEnergyModelContainer container;
+    energy::DeviceEnergyModelContainer container;
     auto dev = deviceContainer.Begin();
     auto src = sourceContainer.Begin();
     while (dev != deviceContainer.End())
     {
         // check to make sure source and net device are on the same node
         NS_ASSERT((*dev)->GetNode() == (*src)->GetNode());
-        Ptr<DeviceEnergyModel> model = DoInstall(*dev, *src);
+        Ptr<energy::DeviceEnergyModel> model = DoInstall(*dev, *src);
         container.Add(model);
         dev++;
         src++;
